/*
A mix of delayed images to the screen
 blend-delay via a map!
 */
import processing.video.*;

Capture camera;
static int fps=30;
/* save three seconds */

PImage timeBuffer[];
final int timeBufferSize=80;
final int blendLevels=16;
final int blendLevelsL2=4;
final int blendLevelsMASK=0x0000000F;

// roughly scale a 6x4 image
final int scale = 40;
 
final int vvw = 6*scale; // video width
final int vvh = 4*scale; // video height
final int svw = 6*scale; // screen width
final int svh = 4*scale; // screen height
final int vwo2=vvw/2;
final int vho2=vvh/2;
int cw,ch;

boolean newFrame = false;
int saving=0;
int iBuffer;
int blendMap[];

int functionType;
int blendType;
PFont myFont; 

Frame controlFrame;

void setup()
{
  int b;
  // 16 for label at the bottom
  size(svw, svh+16);

  camera = new Capture(this, vvw, vvh, fps);
  timeBuffer= new PImage[timeBufferSize];
  for(int i=0;i<timeBufferSize;i++)
    timeBuffer[i] = new PImage(vvw,vvh);


  iBuffer=0;

  b=0;  
  cw=vwo2;
  ch=vho2;
  // String[] fontList = PFont.list(); 
  //println(fontList); 
  myFont = createFont("Arial", 14); 
  fill(64,64,64);
  textFont(myFont);
  functionType=0;
  blendType=0;
  setupBlendMap();

}

// put scaled fps/pixel in this array
void setupBlendMap()
{
  float centerTime=0.0;
  float edgeTime=1.0;

  blendMap= new int[vvw*vvh];

  if(functionType ==0)
  {
    for(int dn=0;dn<vvh;dn++)
      for(int ac=0;ac<vvw;ac++)
      {
        int coord=dn*vvw+ac;
        // some kind of function for fps
        // center should be slow, edge should be fast!
        float dx=(float)(ac-cw)/(float)vvw;
        float dy=(float)(dn-ch)/(float)vvh;
        float r=sqrt(dx*dx+dy*dy);
        // blend amounts... hmmm!
        // the center should blend the most.. about 5%new to 95% old, edge should be 100% new.
        // center == 0, edge can be anything over 1
        if(r<0.1)
        {
          r=centerTime;
        }
        else
        {
          r-=0.1;
          r=pow(lerp(centerTime,edgeTime,min(r,0.99)),0.6);
        } // vw debug
        blendMap[coord]=(int) (((timeBufferSize-1)*blendLevels)*min(1.0,r)) ;


        //if(r<0.01)
        //  println("r:"+r+" dx:"+dx+" dy:"+dy+" bm:"+blendMap[coord]);
      }
 
  }

  if(functionType ==1)
  {
    for(int dn=0;dn<vvh;dn++)
      for(int ac=0;ac<vvw;ac++)
      {
        int coord=dn*vvw+ac;
        // some kind of function for fps
        // center should be slow, edge should be fast!
        float dx=(float)(ac-vwo2)/(float)vwo2;

        float r=abs(dx) ;
        // blend amounts... hmmm!
        // the center should blend the most.. about 5%new to 95% old, edge should be 100% new.
        // center == 0, edge can be anything over 1

        r= lerp(centerTime,edgeTime,min(r,0.99)) ;

        blendMap[coord]=(int) (((timeBufferSize-1)*blendLevels)*min(1.0,r)) ;



        //if(r<0.01)
        //  println("r:"+r+" dx:"+dx+" dy:"+dy+" bm:"+blendMap[coord]);
      }
   

  }

  if(functionType ==2)
  {
    for(int dn=0;dn<vvh;dn++)
      for(int ac=0;ac<vvw;ac++)
      {
        int coord=dn*vvw+ac;
        // some kind of function for fps
        // center should be slow, edge should be fast!


        float r=(float)dn/(float)vvh;
        // blend amounts... hmmm!
        // the center should blend the most.. about 5%new to 95% old, edge should be 100% new.
        // center == 0, edge can be anything over 1

        r= lerp(centerTime,edgeTime,max(0.0,min(r,0.99))) ;

        blendMap[coord]=(int) (((timeBufferSize-1)*blendLevels)*min(1.0,r)) ;


        //  if(r<0.10)
        //  println("r:"+r+" map:"+blendMap[coord]);
      }
 

  }

  if(functionType ==3)
  {

    for(int dn=0;dn<vvh;dn++)
      for(int ac=0;ac<vvw;ac++)
      {
        int coord=dn*vvw+ac;
        // some kind of function for fps
        // center should be slow, edge should be fast!


        float r=(float)brightness(camera.pixels[coord])/256.0;
        // blend amounts... hmmm!
        // the center should blend the most.. about 5%new to 95% old, edge should be 100% new.
        // center == 0, edge can be anything over 1

        r= lerp(centerTime,edgeTime,max(0.0,min(r,0.99))) ;

        blendMap[coord]=(int) (((timeBufferSize-1)*blendLevels)*min(1.0,r)) ;


        //  if(r<0.10)
        //  println("r:"+r+" map:"+blendMap[coord]);
      }
   

  }


}



void captureEvent(Capture camera)
{
  camera.read();
  timeBuffer[iBuffer].copy(camera, 0, 0, vvw,  vvh, 0, 0, vvw, vvh);

  iBuffer++;
  if(iBuffer>=timeBufferSize)
    iBuffer=0;
  newFrame = true;

}



void draw()
{
color c0,c1,clerp;
int RR,GG,BB;

  if(newFrame) {
    //   textFont(myFont); 
 noStroke();
    if(blendType==0)
    {

    }
    if(blendType==1)
    {
      cw=mouseX;
      ch=mouseY;
      setupBlendMap();
    }

    for(int down=0;down<vvh;down++)
    {
      for(int across=0;across<vvw;across++)
      {
        int coord = down*vvw+across;
        int tbuf = (blendMap[coord]>>blendLevelsL2)+iBuffer;
        int tlerp = blendMap[coord]&blendLevelsMASK;
        int tbuf0 =  tbuf % timeBufferSize ;
       // int tbuf1 = min(tbuf+1,timeBufferSize-1);
      //  c0=timeBuffer[tbuf1].pixels[coord];
       // c1=timeBuffer[tbuf0].pixels[coord];
      //  RR= (int)( (red(c0)*tlerp) + (red(c1)*(blendLevelsMASK-tlerp) )) >>blendLevelsL2;
      //   GG= (int)( (green(c0)*tlerp) + (green(c1)*(blendLevelsMASK-tlerp) )) >>blendLevelsL2;
      // BB= (int)( (blue(c0)*tlerp) + (blue(c1)*(blendLevelsMASK-tlerp) )) >>blendLevelsL2;
       //clerp=color(RR,GG,BB);
        //   set(across, down, clerp );
       set(across, down, timeBuffer[tbuf0].pixels[coord] );
       
      }
    }
 drawLabel();
   // for(int down=0;down<vvh;down++)
      //text(iBuffer, 10, 50); 
      // image(timeBuffer,0,0);
      if(saving==1)
      {
        saveFrame("delay/####.tif");
      }
    newFrame = false;
  }
}

void keyPressed(){
  //  println("key:"+keyCode);
  if (keyCode == 16)
  { // press SHIFT to restart saving
    saving = 1-saving;


  }
  if(keyCode== 49)
  {
    functionType=0;
    setupBlendMap();
  }
  if(keyCode== 50)
  {
    functionType=1;
    setupBlendMap();
    blendType=0;

  }
  if(keyCode== 51)
  {
    functionType=2;
    setupBlendMap();
     blendType=0;

 }  

  if(keyCode== 52)
  {
    functionType=3;
    setupBlendMap();
    blendType=0;

 }


  if(keyCode== 53)
  {
    blendType=0;
 }
  if(keyCode== 54)
  {
   blendType=1;
   }

}
 
 
 void drawLabel()
{
String delayModeString,delayTypeString,delaySavingString;

  fill(240,240,240);
  rect(0,svh,svw,svh+20);
  fill(64,64,64);
  
  switch(functionType)
  {
  case 0: delayModeString="Circular";break;
  case 1: delayModeString="Left+Right";break;
  case 2: delayModeString="Bottom to Top";break;
  case 3: delayModeString="Image Brightness";break;
  default:
    delayModeString="?";
    }
    
 switch(blendType)
 {
  case 0: delayTypeString="center";break;
  case 1: delayTypeString="mouse";break;
default:
    delayTypeString="?";

 }
 
delaySavingString="-";
 switch(saving)
 {
  case 0: delaySavingString="-";break;
  case 1: delaySavingString="Saving";break;
default:
  delaySavingString="?";

 }

  
  
  text(delayModeString+" "+delayTypeString+" "+delaySavingString,15,svh+14);
  }

color lerpCol16(color a,color b, int n)
{
  int n1=15-n;
  int aR=(a&RED_MASK)>>16;
  int aG=(a&GREEN_MASK)>>8;
  int aB=(a&BLUE_MASK);
  int bR=(b&RED_MASK)>>16;
  int bG=(b&GREEN_MASK)>>8;
  int bB=(b&BLUE_MASK);
  color r =   color((aR*n+bR*n1)>>4,(aG*n+bG*n1)>>4,(aB*n+bB*n1)>>4);
  return (r);
}
